#include "cora_fit.h"
#include <stdio.h>
#include <stdlib.h>

void lamran ()
{
  
  int i,j;
  double lam_l, lam_o, maxsig, num_sig=3.0, maxshift=2.0;
  double lambda;
  
  maxsig =  max(&lsigma) + dsig;
  lambda = (lamstart+lamend)/2.;
  lam_l  = min(&llambda) - maxshift - (num_sig*maxsig);
  lam_o  = max(&llambda) + maxshift + (num_sig*maxsig);

  if (lamend-lamstart > lam_o-lam_l)
    { 
      num_sig = (lamend-lamstart) / 2. / maxsig;
      lam_l   = lamstart-maxshift;
      lam_o   = lamend+maxshift;
    }

  if (lam_l<min(&wave)) lam_l = min(&wave);
  if (lam_o>max(&wave)) lam_o = max(&wave);


  where2 (&good, &wave, func_ul, &lam_l, &lam_o, &count);

  if (count < 7)
    fprintf (stderr, 
	     "*  Warning  *: Less than 7 bins in range "\
	     "(sigma estimate too small ?)\n");

  vec_alloc(&x,      count);
  vec_alloc(&dx,     count);
  vec_alloc(&ncount, count);
  vec_alloc(&bbb,    count);
  vec_alloc(&bb0,    count);

  for(i=0; i < nlines; ++i) 
    {
      yc[i] = malloc(count*sizeof(double));

      if (yc[i] == NULL)
        {
          fprintf (stderr, "*  Warning  *: Out of memory\n"); 
          exit (8);
        }

      /* initialize yc 
       */
      for (j=0; j < count; ++j) 
	yc[i][j]=0.0;
    }

  return;
}

